diff --git a/tests/unit/modules/test_virt.py b/tests/unit/modules/test_virt.py
index 3e9bd5ef49..d3988464f6 100644
--- a/tests/unit/modules/test_virt.py
+++ b/tests/unit/modules/test_virt.py
@@ -1484,30 +2576,28 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
                    eth1:
                       bridge: br1
                       model: virtio
-        '''
+        """
         mock_config = salt.utils.yaml.safe_load(yaml_config)
-        with patch.dict(salt.modules.config.__opts__, mock_config):  # pylint: disable=no-member
+        with patch.dict(
+            salt.modules.config.__opts__, mock_config  # pylint: disable=no-member
+        ):
 
-            for name in six.iterkeys(mock_config['virt']['nic']):
-                profile = salt.modules.virt._nic_profile(name, 'kvm')
+            for name in six.iterkeys(mock_config["virt"]["nic"]):
+                profile = salt.modules.virt._nic_profile(name, "kvm")
                 self.assertEqual(len(profile), 2)
 
                 interface_attrs = profile[0]
-                self.assertIn('source', interface_attrs)
-                self.assertIn('type', interface_attrs)
-                self.assertIn('name', interface_attrs)
-                self.assertIn('model', interface_attrs)
-                self.assertEqual(interface_attrs['model'], 'virtio')
-                self.assertIn('mac', interface_attrs)
-                self.assertTrue(
-                    re.match('^([0-9A-F]{2}[:-]){5}([0-9A-F]{2})$',
-                             interface_attrs['mac'], re.I))
+                self.assertIn("source", interface_attrs)
+                self.assertIn("type", interface_attrs)
+                self.assertIn("name", interface_attrs)
+                self.assertIn("model", interface_attrs)
+                self.assertEqual(interface_attrs["model"], "virtio")
 
     def test_get_xml(self):
-        '''
+        """
         Test virt.get_xml()
-        '''
-        xml = '''<domain type='kvm' id='7'>
+        """
+        xml = """<domain type='kvm' id='7'>
               <name>test-vm</name>
               <devices>
                 <graphics type='vnc' port='5900' autoport='yes' listen='0.0.0.0'>
@@ -1515,16 +2605,33 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
                 </graphics>
               </devices>
             </domain>
-        '''
+        """
         domain = self.set_mock_vm("test-vm", xml)
-        self.assertEqual(xml, virt.get_xml('test-vm'))
+        self.assertEqual(xml, virt.get_xml("test-vm"))
         self.assertEqual(xml, virt.get_xml(domain))
 
+    def test_get_loader(self):
+        """
+        Test virt.get_loader()
+        """
+        xml = """<domain type='kvm' id='7'>
+              <name>test-vm</name>
+              <os>
+                <loader readonly='yes' type='pflash'>/foo/bar</loader>
+              </os>
+            </domain>
+        """
+        self.set_mock_vm("test-vm", xml)
+
+        loader = virt.get_loader("test-vm")
+        self.assertEqual("/foo/bar", loader["path"])
+        self.assertEqual("yes", loader["readonly"])
+
     def test_parse_qemu_img_info(self):
-        '''
+        """
         Make sure that qemu-img info output is properly parsed
-        '''
-        qemu_infos = '''[{
+        """
+        qemu_infos = """[{
             "snapshots": [
                 {
                     "vm-clock-nsec": 0,
@@ -1598,57 +2705,61 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
                 }
             },
             "dirty-flag": false
-        }]'''
+        }]"""
 
         self.assertEqual(
             {
-                'file': '/disks/test.qcow2',
-                'file format': 'qcow2',
-                'backing file': {
-                    'file': '/disks/mybacking.qcow2',
-                    'file format': 'qcow2',
-                    'disk size': 393744384,
-                    'virtual size': 25769803776,
-                    'cluster size': 65536,
-                    'backing file': {
-                        'file': '/disks/root.qcow2',
-                        'file format': 'qcow2',
-                        'disk size': 196872192,
-                        'virtual size': 25769803776,
-                        'cluster size': 65536,
-                    }
+                "file": "/disks/test.qcow2",
+                "file format": "qcow2",
+                "backing file": {
+                    "file": "/disks/mybacking.qcow2",
+                    "file format": "qcow2",
+                    "disk size": 393744384,
+                    "virtual size": 25769803776,
+                    "cluster size": 65536,
+                    "backing file": {
+                        "file": "/disks/root.qcow2",
+                        "file format": "qcow2",
+                        "disk size": 196872192,
+                        "virtual size": 25769803776,
+                        "cluster size": 65536,
+                    },
                 },
-                'disk size': 217088,
-                'virtual size': 25769803776,
-                'cluster size': 65536,
-                'snapshots': [
+                "disk size": 217088,
+                "virtual size": 25769803776,
+                "cluster size": 65536,
+                "snapshots": [
                     {
-                        'id': '1',
-                        'tag': 'first-snap',
-                        'vmsize': 1234,
-                        'date': datetime.datetime.fromtimestamp(
-                            float("{}.{}".format(1528877587, 380589000))).isoformat(),
-                        'vmclock': '00:00:00'
+                        "id": "1",
+                        "tag": "first-snap",
+                        "vmsize": 1234,
+                        "date": datetime.datetime.fromtimestamp(
+                            float("{}.{}".format(1528877587, 380589000))
+                        ).isoformat(),
+                        "vmclock": "00:00:00",
                     },
                     {
-                        'id': '2',
-                        'tag': 'second snap',
-                        'vmsize': 4567,
-                        'date': datetime.datetime.fromtimestamp(
-                            float("{}.{}".format(1528877592, 933509000))).isoformat(),
-                        'vmclock': '00:00:00'
-                    }
+                        "id": "2",
+                        "tag": "second snap",
+                        "vmsize": 4567,
+                        "date": datetime.datetime.fromtimestamp(
+                            float("{}.{}".format(1528877592, 933509000))
+                        ).isoformat(),
+                        "vmclock": "00:00:00",
+                    },
                 ],
-            }, virt._parse_qemu_img_info(qemu_infos))
+            },
+            virt._parse_qemu_img_info(qemu_infos),
+        )
 
-    @patch('salt.modules.virt.stop', return_value=True)
-    @patch('salt.modules.virt.undefine')
-    @patch('os.remove')
+    @patch("salt.modules.virt.stop", return_value=True)
+    @patch("salt.modules.virt.undefine")
+    @patch("os.remove")
     def test_purge_default(self, mock_remove, mock_undefine, mock_stop):
-        '''
+        """
         Test virt.purge() with default parameters
-        '''
-        xml = '''<domain type='kvm' id='7'>
+        """
+        xml = """<domain type='kvm' id='7'>
               <name>test-vm</name>
               <devices>
                 <disk type='file' device='disk'>
@@ -1664,10 +2775,10 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
               </disk>
               </devices>
             </domain>
-        '''
+        """
         self.set_mock_vm("test-vm", xml)
 
-        qemu_infos = '''[{
+        qemu_infos = """[{
             "virtual-size": 25769803776,
             "filename": "/disks/test.qcow2",
             "cluster-size": 65536,
@@ -1683,23 +2794,157 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
                 }
             },
             "dirty-flag": false
-        }]'''
+        }]"""
+
+        self.mock_popen.communicate.return_value = [
+            qemu_infos
+        ]  # pylint: disable=no-member
+
+        with patch.dict(os.path.__dict__, {"exists": MagicMock(return_value=True)}):
+            res = virt.purge("test-vm")
+            self.assertTrue(res)
+            mock_remove.assert_called_once()
+            mock_remove.assert_any_call("/disks/test.qcow2")
+
+    @patch("salt.modules.virt.stop", return_value=True)
+    @patch("salt.modules.virt.undefine")
+    def test_purge_volumes(self, mock_undefine, mock_stop):
+        """
+        Test virt.purge() with volume disks
+        """
+        xml = """<domain type='kvm' id='7'>
+              <name>test-vm</name>
+              <devices>
+                <disk type='volume' device='disk'>
+                  <driver name='qemu' type='qcow2' cache='none' io='native'/>
+                  <source pool='default' volume='vm05_system'/>
+                  <backingStore type='file' index='1'>
+                    <format type='qcow2'/>
+                    <source file='/var/lib/libvirt/images/vm04_system.qcow2'/>
+                    <backingStore type='file' index='2'>
+                      <format type='qcow2'/>
+                      <source file='/var/testsuite-data/disk-image-template.qcow2'/>
+                      <backingStore/>
+                    </backingStore>
+                  </backingStore>
+                  <target dev='vda' bus='virtio'/>
+                  <alias name='virtio-disk0'/>
+                  <address type='pci' domain='0x0000' bus='0x00' slot='0x04' function='0x0'/>
+                </disk>
+              </devices>
+            </domain>
+        """
+        self.set_mock_vm("test-vm", xml)
 
-        self.mock_popen.communicate.return_value = [qemu_infos]  # pylint: disable=no-member
+        pool_mock = MagicMock()
+        pool_mock.storageVolLookupByName.return_value.info.return_value = [
+            0,
+            1234567,
+            12345,
+        ]
+        pool_mock.storageVolLookupByName.return_value.XMLDesc.return_value = [
+            """
+            <volume type='file'>
+              <name>vm05_system</name>
+              <target>
+                <path>/var/lib/libvirt/images/vm05_system</path>
+                <format type='qcow2'/>
+              </target>
+              <backingStore>
+                <path>/var/lib/libvirt/images/vm04_system.qcow2</path>
+                <format type='qcow2'/>
+              </backingStore>
+            </volume>
+            """,
+        ]
+        pool_mock.listVolumes.return_value = ["vm05_system", "vm04_system.qcow2"]
+        self.mock_conn.storagePoolLookupByName.return_value = pool_mock
+        self.mock_conn.listStoragePools.return_value = ["default"]
+
+        with patch.dict(os.path.__dict__, {"exists": MagicMock(return_value=False)}):
+            res = virt.purge("test-vm")
+            self.assertTrue(res)
+            pool_mock.storageVolLookupByName.return_value.delete.assert_called_once()
+
+    @patch("salt.modules.virt.stop", return_value=True)
+    @patch("salt.modules.virt.undefine")
+    def test_purge_rbd(self, mock_undefine, mock_stop):
+        """
+        Test virt.purge() with RBD disks
+        """
+        xml = """<domain type='kvm' id='7'>
+              <name>test-vm</name>
+              <devices>
+                <disk type="network" device="disk">
+                  <driver name='raw' type='qcow2'/>
+                  <source protocol='rbd' name='libvirt-pool/my_vm_data2'>
+                    <host name='ses2.tf.local'/>
+                    <host name='ses3.tf.local' port='1234'/>
+                    <auth username='libvirt'>
+                      <secret type='ceph' usage='pool_test-rbd'/>
+                    </auth>
+                  </source>
+                  <target dev='vdc' bus='virtio'/>
+                  <alias name='virtio-disk2'/>
+                  <address type='pci' domain='0x0000' bus='0x00' slot='0x07' function='0x2'/>
+                </disk>
+              </devices>
+            </domain>
+        """
+        self.set_mock_vm("test-vm", xml)
 
-        res = virt.purge('test-vm')
-        self.assertTrue(res)
-        mock_remove.assert_any_call('/disks/test.qcow2')
-        mock_remove.assert_any_call('/disks/test-cdrom.iso')
-
-    @patch('salt.modules.virt.stop', return_value=True)
-    @patch('salt.modules.virt.undefine')
-    @patch('os.remove')
-    def test_purge_noremovable(self, mock_remove, mock_undefine, mock_stop):
-        '''
-        Test virt.purge(removables=False)
-        '''
-        xml = '''<domain type='kvm' id='7'>
+        pool_mock = MagicMock()
+        pool_mock.storageVolLookupByName.return_value.info.return_value = [
+            0,
+            1234567,
+            12345,
+        ]
+        pool_mock.XMLDesc.return_value = """
+        <pool type='rbd'>
+          <name>test-ses</name>
+          <source>
+            <host name='ses2.tf.local'/>
+            <name>libvirt-pool</name>
+            <auth type='ceph' username='libvirt'>
+              <secret usage='pool_test-ses'/>
+            </auth>
+          </source>
+        </pool>
+        """
+        pool_mock.name.return_value = "test-ses"
+        pool_mock.storageVolLookupByName.return_value.XMLDesc.return_value = [
+            """
+            <volume type='network'>
+              <name>my_vm_data2</name>
+              <source>
+              </source>
+              <capacity unit='bytes'>536870912</capacity>
+              <allocation unit='bytes'>0</allocation>
+              <target>
+                <path>libvirt-pool/my_vm_data2</path>
+                <format type='raw'/>
+              </target>
+            </volume>
+            """,
+        ]
+        pool_mock.listVolumes.return_value = ["my_vm_data2"]
+        self.mock_conn.listAllStoragePools.return_value = [pool_mock]
+        self.mock_conn.listStoragePools.return_value = ["test-ses"]
+        self.mock_conn.storagePoolLookupByName.return_value = pool_mock
+
+        with patch.dict(os.path.__dict__, {"exists": MagicMock(return_value=False)}):
+            res = virt.purge("test-vm")
+            self.assertTrue(res)
+            pool_mock.storageVolLookupByName.return_value.delete.assert_called_once()
+
+    @patch("salt.modules.virt.stop", return_value=True)
+    @patch("salt.modules.virt.undefine")
+    @patch("os.remove")
+    def test_purge_removable(self, mock_remove, mock_undefine, mock_stop):
+        """
+        Test virt.purge(removables=True)
+        """
+        xml = """<domain type="kvm" id="7">
               <name>test-vm</name>
               <devices>
                 <disk type='file' device='disk'>
@@ -1721,10 +2966,10 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
               </disk>
               </devices>
             </domain>
-        '''
+        """
         self.set_mock_vm("test-vm", xml)
 
-        qemu_infos = '''[{
+        qemu_infos = """[{
             "virtual-size": 25769803776,
             "filename": "/disks/test.qcow2",
             "cluster-size": 65536,
@@ -1740,20 +2985,23 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
                 }
             },
             "dirty-flag": false
-        }]'''
+        }]"""
 
-        self.mock_popen.communicate.return_value = [qemu_infos]  # pylint: disable=no-member
+        self.mock_popen.communicate.return_value = [
+            qemu_infos
+        ]  # pylint: disable=no-member
 
-        res = virt.purge('test-vm', removables=False)
-        self.assertTrue(res)
-        mock_remove.assert_called_once()
-        mock_remove.assert_any_call('/disks/test.qcow2')
+        with patch.dict(os.path.__dict__, {"exists": MagicMock(return_value=True)}):
+            res = virt.purge("test-vm", removables=True)
+            self.assertTrue(res)
+            mock_remove.assert_any_call("/disks/test.qcow2")
+            mock_remove.assert_any_call("/disks/test-cdrom.iso")
 
     def test_capabilities(self):
-        '''
+        """
         Test the virt.capabilities parsing
-        '''
-        xml = '''
+        """
+        xml = """
 <capabilities>
   <host>
     <uuid>44454c4c-3400-105a-8033-b3c04f4b344a</uuid>
